/* Sistemas Integrados TECNISA

Nome: 99PL_FISTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
Tabela CONSISTEFISCAL: Consistncias Fiscais.
Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CONSISTEFISCAL
*/

CREATE OR REPLACE TRIGGER LOG_FIS_CONSISTEFISCAL
AFTER DELETE OR INSERT OR UPDATE
ON CONSISTEFISCAL FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(3000);
  V_USUARIO      VARCHAR2(40);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_DTOPER       DATE;

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF UPDATING THEN
      V_DESC   := 'Consistncia = '         || '' || :NEW.NRSEQCONSISTE                       || ' ' ||
                  'Imposto = '              || '' || :NEW.CDIMPOSTO                           || ' ' ||
                  'E/S = '                  || '' || :NEW.IDENTRSAIDOP                        || ' ' ||
                  'CFOP = '                 || '' || :NEW.CDFISCOPER                          || ' ' ||
                  '1 Dig. Cst = '           || '' || :NEW.CDCST1DIGT                          || ' ' ||
                  'Cst = '                  || '' || :NEW.CDSITUTRIB                          || ' ' ||
                  'CF = '                   || '' || :NEW.CDFISCAL                            || ' ' ||
                  'Tp. Credto = '           || '' || :NEW.CDTPCREDPICOITE                     || ' ' ||
                  'BC = '                   || '' || :NEW.IDTPBASECALC                        || ' ' ||
                  'Aliq = '                 || '' || :NEW.IDTPALIQUOTA                        || ' ' ||
                  'Imp = '                  || '' || :NEW.IDTPVRIMPOSTO                       || ' ' ||
                  'Cons. Lanc = '           || '' || :NEW.IDCONSISTELANC                      || ' ' ||
                  'Cons. Aprov = '          || '' || :NEW.IDCONSISTEAPRO                      || ' ' ||
                  'Pre def. = '             || '' || :NEW.IDCONSPREDEFI                       || ' ' ||
                  'Cons. Ativa = '          || '' || :NEW.IDCONSATIVA                         || ' ' ||
                  'Bloqueio = '             || '' || :NEW.IDBLOQADMI;

      V_ITPESQ       := :OLD.CDIMPOSTO||:OLD.NRSEQCONSISTE;
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC   := 'Consistncia = '         || '' || :NEW.NRSEQCONSISTE                       || ' ' ||
                     'Descrio = '            || '' || :NEW.DSCONSISTENCIA                      || ' ' ||
                     'Imposto = '              || '' || :NEW.CDIMPOSTO                           || ' ' ||
                     'E/S = '                  || '' || :NEW.IDENTRSAIDOP                        || ' ' ||
                     'CFOP = '                 || '' || :NEW.CDFISCOPER                          || ' ' ||
                     '1 Dig. Cst = '           || '' || :NEW.CDCST1DIGT                          || ' ' ||
                     'Cst = '                  || '' || :NEW.CDSITUTRIB                          || ' ' ||
                     'CF = '                   || '' || :NEW.CDFISCAL                            || ' ' ||
                     'Tp. Credto = '           || '' || :NEW.CDTPCREDPICOITE                     || ' ' ||
                     'BC = '                   || '' || :NEW.IDTPBASECALC                        || ' ' ||
                     'Aliq = '                 || '' || :NEW.IDTPALIQUOTA                        || ' ' ||
                     'Imp = '                  || '' || :NEW.IDTPVRIMPOSTO                       || ' ' ||
                     'Cons. Lanc = '           || '' || :NEW.IDCONSISTELANC                      || ' ' ||
                     'Cons. Aprov = '          || '' || :NEW.IDCONSISTEAPRO                      || ' ' ||
                     'Pre def. = '             || '' || :NEW.IDCONSPREDEFI                       || ' ' ||
                     'Cons. Ativa = '          || '' || :NEW.IDCONSATIVA                         || ' ' ||
                     'Bloqueio = '             || '' || :NEW.IDBLOQADMI;

         V_ITPESQ       := :NEW.CDIMPOSTO||:NEW.NRSEQCONSISTE;
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING THEN
            V_DESC   := 'Consistncia = '         || '' || :NEW.NRSEQCONSISTE                       || ' ' ||
                        'Imposto = '              || '' || :NEW.CDIMPOSTO                           || ' ' ||
                        'E/S = '                  || '' || :NEW.IDENTRSAIDOP                        || ' ' ||
                        'CFOP = '                 || '' || :NEW.CDFISCOPER                          || ' ' ||
                        '1 Dig. Cst = '           || '' || :NEW.CDCST1DIGT                          || ' ' ||
                        'Cst = '                  || '' || :NEW.CDSITUTRIB                          || ' ' ||
                        'CF = '                   || '' || :NEW.CDFISCAL                            || ' ' ||
                        'Tp. Credto = '           || '' || :NEW.CDTPCREDPICOITE                     || ' ' ||
                        'BC = '                   || '' || :NEW.IDTPBASECALC                        || ' ' ||
                        'Aliq = '                 || '' || :NEW.IDTPALIQUOTA                        || ' ' ||
                        'Imp = '                  || '' || :NEW.IDTPVRIMPOSTO                       || ' ' ||
                        'Cons. Lanc = '           || '' || :NEW.IDCONSISTELANC                      || ' ' ||
                        'Cons. Aprov = '          || '' || :NEW.IDCONSISTEAPRO                      || ' ' ||
                        'Pre def. = '             || '' || :NEW.IDCONSPREDEFI                       || ' ' ||
                        'Cons. Ativa = '          || '' || :NEW.IDCONSATIVA                         || ' ' ||
                        'Bloqueio = '             || '' || :NEW.IDBLOQADMI;
            V_ITPESQ       := :OLD.CDIMPOSTO||:OLD.NRSEQCONSISTE;
            V_IDTIPOOPER   := '3';
         END IF;
      END IF;
   END IF;

   V_DESC := SUBSTR(V_DESC, 1, 400);
   V_DTOPER := SYSDATE;

   INSERT INTO LOGCONSISTEFISCAL
               (NMTABELA,
                DTOPERACAO,
                NMRESPOPER,
                IDTIPOOPER,
                CDPESQITEM,
                DSOPERACAO,
                DSRDMUSUOPER,
                DSENDUSUOPER,
                DSNMUSUOPER,
                DSMETUSUOPER,
                CDORESPOPER)
            VALUES
               ('CONSISTEFISCAL',
                V_DTOPER,
                V_NMOPERADOR,
                V_IDTIPOOPER,
                V_ITPESQ,
                V_DESC,
                V_DSSERVERRDM,
                V_DSREMOTEADDR,
                V_DSREMOTEHOST,
                V_DSSERVMETHOD,
                V_DSREMOTEOPER);

END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIS_CONSISTEFISCAL','5.33.xxx'); END;
/
