/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_COMESERVTCAR                                             */
/* Tabela : COMESERVTCAR                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 08/03/2005 - Henrique Dias Borges                                          */
/*                                                                            */
/******************************************************************************/
IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_COMESERVTCAR' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_COMESERVTCAR
GO

CREATE TRIGGER DTULTATU_COMESERVTCAR
ON COMESERVTCAR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'COMESERVTCAR', NULL, 'CDFILCENTPME='+ CDFILCENTPME+';'+'CDTIPOCARD='+ CDTIPOCARD+';'+'CDSERVFILI='+ CDSERVFILI+';'+'CDFILIAL='+ CDFILIAL+';',GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE COMESERVTCAR
      SET DTULTATUCSTC = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(COMESERVTCAR.CDFILCENTPME,0) = ISNULL(INSERTED.CDFILCENTPME,0)) AND
            (ISNULL(COMESERVTCAR.CDTIPOCARD,0) = ISNULL(INSERTED.CDTIPOCARD,0)) AND
            (ISNULL(COMESERVTCAR.CDSERVFILI,0) = ISNULL(INSERTED.CDSERVFILI,0)) AND
            (ISNULL(COMESERVTCAR.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0))   ;
   END;
END;
GO
