IF EXISTS(SELECT *
            FROM SYSOBJECTS, SYSUSERS
           WHERE SYSOBJECTS.NAME = 'STATUS_LOTECTB_TRANSFBANC'
             AND TYPE   = 'TR'
             AND SYSUSERS.UID  = SYSOBJECTS.UID
             AND SYSUSERS.NAME = USER)
   DROP TRIGGER STATUS_LOTECTB_TRANSFBANC;
GO

CREATE TRIGGER STATUS_LOTECTB_TRANSFBANC ON TRANSFBANC
FOR DELETE, UPDATE
AS
DECLARE @V_CDLOTE            VARCHAR(20);
DECLARE @V_NRLANCLOTE        VARCHAR(06);
DECLARE @V_DTINICCTBL        DATETIME;
DECLARE @V_DTFINACCTBL       DATETIME;
DECLARE @V_CDEMPRESA         VARCHAR(2);
DECLARE @OLD_CDEMPRESA       VARCHAR(2);
DECLARE @OLD_DTTRANBANC      DATETIME;
DECLARE @OLD_NRTRANBANC      VARCHAR(10);
DECLARE @NEW_IDSTATUSCTBL    VARCHAR(01);
DECLARE @OLD_IDSTATUSCTBL    VARCHAR(01);
DECLARE @V_IDTPGERACAOCONT   VARCHAR(01);
DECLARE @V_INSERTED          INT;
DECLARE @V_DELETED           INT;
BEGIN

   SELECT @V_IDTPGERACAOCONT = IDTPGERACAOCONT FROM PARAMCTBL;

   IF @V_IDTPGERACAOCONT <> 'O' BEGIN

      DECLARE C_TRANSFBANC CURSOR FOR
         SELECT CDEMPRESA, DTTRANBANC, NRTRANBANC, IDSTATUSCTBL
           FROM DELETED;
      OPEN C_TRANSFBANC;

      FETCH NEXT FROM C_TRANSFBANC INTO @OLD_CDEMPRESA, @OLD_DTTRANBANC, @OLD_NRTRANBANC, @OLD_IDSTATUSCTBL;
      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT @V_DTINICCTBL = DTINICCTBL, @V_DTFINACCTBL = DTFINACCTBL
           FROM CONTOPECTBL
          WHERE CDEMPRESA = @OLD_CDEMPRESA;

         SELECT @V_INSERTED = COUNT(*) FROM INSERTED;

         SELECT @V_DELETED = COUNT(*) FROM DELETED;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF ((@V_DELETED <> 0) AND (@V_INSERTED = 0)) BEGIN
               IF ((@OLD_DTTRANBANC >= @V_DTINICCTBL) AND (@OLD_DTTRANBANC <= @V_DTFINACCTBL)) BEGIN
                  DECLARE C_RELACTRANSFLANC CURSOR FOR
                     SELECT MAX(CDLOTE) AS CDLOTE, MAX(NRLANCLOTE) AS NRLANCLOTE
                       FROM RELACTRANSFLANC
                      WHERE CDEMPRESA  = @OLD_CDEMPRESA
                        AND NRTRANBANC = @OLD_NRTRANBANC;
                  OPEN C_RELACTRANSFLANC;

                  FETCH NEXT FROM C_RELACTRANSFLANC INTO @V_CDLOTE, @V_NRLANCLOTE;
                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     DELETE FROM RELACTRANSFLANC
                      WHERE CDEMPRESA = @OLD_CDEMPRESA
                        AND NRLANCLOTE = @V_NRLANCLOTE
                        AND NRTRANBANC = @OLD_NRTRANBANC;

                     DELETE FROM LANCLOTE
                      WHERE CDEMPRESA = @OLD_CDEMPRESA
                        AND CDLOTE = @V_CDLOTE
                        AND NRLANCLOTE = @V_NRLANCLOTE;

                     EXEC REVERTE_LOTE @OLD_CDEMPRESA, @V_CDLOTE;

                     FETCH NEXT FROM C_RELACTRANSFLANC INTO @V_CDLOTE, @V_NRLANCLOTE;
                  END;
                  CLOSE C_RELACTRANSFLANC;
                  DEALLOCATE C_RELACTRANSFLANC;
               END
               ELSE BEGIN
                  RAISERROR('Excluso no permitida, data da trasferncia fora do perodo de integrao financeiro.', 16,1);
               END;
            END;
            FETCH NEXT FROM C_TRANSFBANC INTO @OLD_CDEMPRESA, @OLD_DTTRANBANC, @OLD_NRTRANBANC, @OLD_IDSTATUSCTBL;
         END;
         CLOSE C_TRANSFBANC;
         DEALLOCATE C_TRANSFBANC;
      END;
   END;
END;
GO
