CREATE OR REPLACE TRIGGER USR_ATUALIZA_QTPROGENTAF_OL
BEFORE INSERT ON ITEMAUTF
FOR EACH ROW
DECLARE
  V_IDFUNCAOFILI     VARCHAR2(1);
  V_VRFATOCONV       FLOAT := 0;
  V_VRARREDCMP       FLOAT := 0;
  V_VRFATOCONVORIG   FLOAT := 0;
  V_CDFORNECED       FORNECEDOR.CDFORNECED%TYPE;
  V_CDREGIAO         REGIAO.CDREGIAO%TYPE;
  V_CDFILCENTCMP     FILIAL.CDFILCENTCMP%TYPE;
  V_VRPRECUNIITM     ITEMCOLE.VRPRECUNIITM%TYPE;
  V_CDPRODUTO        PRODUTO.CDPRODUTO%TYPE;
  V_CDOPERADOR       OPERADOR.CDOPERADOR%TYPE;
  V_NRSEQITMAP       ITMAPURPREC.NRSEQITMAP%TYPE;
  V_QTPROGENTAF      ITEMAUTF.QTPROGENTAF%TYPE;
  V_CDPRODESTO       PRODUTO.CDPRODESTO%TYPE;
  V_IDTIPOLANCAF     AUTOFORNE.IDTIPOLANCAF%TYPE;
BEGIN
   SELECT NVL(MAX(IDTIPOLANCAF), 0)
     INTO V_IDTIPOLANCAF 
     FROM AUTOFORNE
    WHERE CDFILDEST = :NEW.CDFILDEST
      AND CDFILLANC = :NEW.CDFILLANC
      AND NRAUTOFORN = :NEW.NRAUTOFORN;
   SELECT NVL(MAX(IDFUNCAOFILI), 'C'), NVL(MAX(CDREGIAO), 'C'), NVL(MAX(FILIAL.CDFILCENTCMP), MAX(FILIAL.CDFILIAL))
     INTO V_IDFUNCAOFILI, V_CDREGIAO, V_CDFILCENTCMP
     FROM FILIAL
    WHERE CDFILIAL = :NEW.CDFILDEST;
   IF ((V_IDFUNCAOFILI = 'O') AND (V_IDTIPOLANCAF = 'A')) THEN
      SELECT
         NVL(MAX(PRODUTOOL.VRFATOCONV), 0), MAX(PRODUTO.CDPRODUTO), CASE NVL(MAX(PRODUTOOL.VRARREDCMP), 0)
                                                                       WHEN 0
                                                                       THEN 1
                                                                       ELSE NVL(MAX(PRODUTOOL.VRARREDCMP), 0)
                                                                    END, CASE NVL(MAX(PRODUTO.VRFATOCONV), 0)
                                                                            WHEN 0
                                                                            THEN 1
                                                                            ELSE NVL(MAX(PRODUTO.VRFATOCONV), 0)
                                                                         END, MAX(PRODUTO.CDPRODESTO)
      INTO
         V_VRFATOCONV, V_CDPRODUTO, V_VRARREDCMP, V_VRFATOCONVORIG, V_CDPRODESTO
      FROM
         RELACPRODOL, PRODUTO, PRODUTO PRODUTOOL
      WHERE RELACPRODOL.CDPRODARVOL = :NEW.CDPRODUTO
        AND RELACPRODOL.CDMARCA     = :NEW.CDMARCA
        AND RELACPRODOL.CDPRARVORIG = PRODUTO.CDPRODUTO
        AND RELACPRODOL.CDPRODARVOL = PRODUTOOL.CDPRODUTO
        AND PRODUTO.CDPRODESTO      = PRODUTOOL.CDPRODESTO
        AND RELACPRODOL.CDPRARVORIG <> RELACPRODOL.CDPRODARVOL;
      IF ((V_VRFATOCONV > 0) AND (V_CDPRODUTO <> :NEW.CDPRODUTO)) THEN
         SELECT MAX(CDFORNECED)
           INTO V_CDFORNECED
           FROM AUTOFORNE
          WHERE CDFILDEST  = :NEW.CDFILDEST
            AND CDFILLANC  = :NEW.CDFILLANC
            AND NRAUTOFORN = :NEW.NRAUTOFORN;
         SELECT NVL(MIN(VRPRECUNIITM), 0)
           INTO V_VRPRECUNIITM
           FROM ITEMCOLE
          WHERE CDFILIAL   = V_CDFILCENTCMP
            AND CDMARCA    = :NEW.CDMARCA
            AND CDREGIAO   = V_CDREGIAO
            AND CDFORNECED = V_CDFORNECED
            AND CDPRODUTO  = :NEW.CDPRODUTO
            AND :NEW.DTPROGENTAF BETWEEN DTINIVALITM  AND DTFINVALITM;
         IF V_VRPRECUNIITM > 0 THEN
            :NEW.VRPREUNIAF  := V_VRPRECUNIITM;
            SELECT MAX(CDOPERADOR), MAX(CDFORNECED), MAX(NRSEQAPURAF)
              INTO V_CDOPERADOR, V_CDFORNECED, V_NRSEQITMAP
              FROM AUTOFORNE
             WHERE CDFILDEST  = :NEW.CDFILDEST
               AND CDFILLANC  = :NEW.CDFILLANC
               AND NRAUTOFORN = :NEW.NRAUTOFORN;
            SELECT CASE NVL(MAX(VRARREDCMP), 0)
                      WHEN 0
                      THEN 1
                      ELSE NVL(MAX(VRARREDCMP), 0)
                   END,
                   CASE NVL(MAX(VRFATOCONV), 0)
                      WHEN 0
                      THEN 1
                      ELSE NVL(MAX(VRFATOCONV), 0)
                   END,
                   MAX(PRODUTO.CDPRODESTO)
              INTO V_VRARREDCMP, V_VRFATOCONV, V_CDPRODESTO
              FROM PRODUTO
             WHERE PRODUTO.CDPRODUTO = :NEW.CDPRODUTO;

            SELECT SUM(NVL(I.QTSOLIPROD, 0)*NVL(P.VRFATOCONV, 1))/V_VRFATOCONV
              INTO V_QTPROGENTAF
              FROM ITEMSOLI I, PRODUTO P
             WHERE I.CDFILSOLI  = :NEW.CDFILDEST
               AND I.CDPRODUTO  = P.CDPRODUTO
               AND P.CDPRODESTO = V_CDPRODESTO
               AND NVL(I.IDITMCONS, 'N')  = 'N'
               AND NVL(I.IDSOLIAPROV, 'S') = 'S'
               AND I.CDFILIOPELOG IS NULL
               AND I.DTPROGENTR = :NEW.DTENTRITMSOL;
               IF (MOD(V_QTPROGENTAF, V_VRARREDCMP) <> 0) AND V_VRARREDCMP > 0 THEN
                  V_QTPROGENTAF := CEIL(V_QTPROGENTAF / V_VRARREDCMP) * V_VRARREDCMP;
               END IF;
            IF V_QTPROGENTAF > 0 THEN   
            :NEW.QTPROGENTAF := V_QTPROGENTAF;
            END IF;

           
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_ATUALIZA_QTPROGENTAF_OL','5.33.XXX'); END;
/
