/******************************************************************************************/
/******************************************************************************************/
/* Trigger: DTULTATU_DESGRUPROMOCPR                                                       */
/* Tabela : DESGRUPROMOCPR                                                                */
/*                                                                                        */
/* Criao:                                                                               */
/* 10/10/2008 - Wanderson Aloisio                                                         */
/*                                                                                        */
/******************************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_DESGRUPROMOCPR'  and
            type = 'TR' and
            u.uid = o.uid and
            u.name = USER)
   DROP TRIGGER DTULTATU_DESGRUPROMOCPR
GO

CREATE TRIGGER DTULTATU_DESGRUPROMOCPR
ON DESGRUPROMOCPR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                      (SELECT 'DESGRUPROMOCPR', NULL, 'CDGRUPROMOC='+CDGRUPROMOC+
                                                      ';CDPRODPROMOCAO='+CDPRODPROMOCAO+
                                                      ';CDPRODUTO='+CDPRODUTO+';', GETDATE() FROM DELETED)
   END ELSE BEGIN
      UPDATE DESGRUPROMOCPR
      SET DTULTATUDESPR = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(DESGRUPROMOCPR.CDGRUPROMOC,0) = ISNULL(INSERTED.CDGRUPROMOC,0)) AND
            (ISNULL(DESGRUPROMOCPR.CDPRODPROMOCAO,0) = ISNULL(INSERTED.CDPRODPROMOCAO,0)) AND
            (ISNULL(DESGRUPROMOCPR.CDPRODUTO,0) = ISNULL(INSERTED.CDPRODUTO,0));
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_DESGRUPROMOCPR','5.05.023';
GO

