/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3913_CDPSTP0.SQL

Descrio:
Rotina para gerao de Ordem de Produo (OP) e Previso de compras
das matrias primas do MRP.

PARA DEBUGAR
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
28/09/2004 - Fabrcio Marcelo da Silva
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'GERA_OP_PREVCOMP'  and
            type = 'P'                   and
            u.uid = o.uid                and
            u.name = USER)
  DROP PROCEDURE GERA_OP_PREVCOMP
  GO

CREATE PROCEDURE GERA_OP_PREVCOMP
   @P_CDFILIAL      VARCHAR(4),
   @P_DTMRP         DATETIME,
   @P_DSORDPROD     TEXT,
   @P_CDOPERADOR    VARCHAR(12),
   @P_NRPREVCOMP    VARCHAR(10),
   @P_NRPLANOPROD   VARCHAR(10),
   @P_STLISTAPEDIDO VARCHAR(10) = ''
AS
   DECLARE @V_DSNUMELOTEPR   VARCHAR(50);
   DECLARE @V_DSSEQULOTEPR   VARCHAR(50);
   DECLARE @V_SEQNRORDPROD   VARCHAR(20);
   DECLARE @V_NRORDPROD      VARCHAR(10);
   DECLARE @V_NRLOTEESTQ     VARCHAR(20);
   DECLARE @V_NRSUBLOTE      VARCHAR(4);
   DECLARE @V_PRODPREVI      VARCHAR(10);
   DECLARE @V_CDSETORPROD    VARCHAR(4);
   DECLARE @V_NRSEQPREVI     VARCHAR(4);
   DECLARE @V_EXISPREVI      VARCHAR(10);
   DECLARE @V_NOVOCODOP      VARCHAR(13);
   DECLARE @V_NRORDENAOP     VARCHAR(10);
   DECLARE @V_NRORDENASUBOP  VARCHAR(1);
   DECLARE @V_DTVALILOTE     DATETIME;
   DECLARE @V_IDSUBOPSEMIACA VARCHAR(1);
   DECLARE @V_QTHRSEGPROD    NUMERIC;
   DECLARE @V_CTLOTE         NUMERIC;

   DECLARE @C_CALECOMP_CDPRODUTO      VARCHAR(10);
   DECLARE @C_CALECOMP_CDPROCFABRIC   VARCHAR(10);
   DECLARE @C_CALECOMP_DTVALIDADE     DATETIME;
   DECLARE @C_CALECOMP_DTCONCPROMRP   DATETIME;
   DECLARE @C_CALECOMP_QTAFABRICMRP   DOUBLE PRECISION;
   DECLARE @C_CALECOMP_NRORDENAOP     VARCHAR(10);
   DECLARE @C_CALECOMP_NRORDENASUBOP  VARCHAR(1);
   DECLARE @C_CALECOMP_CDPRODFINAL    VARCHAR(10);
   DECLARE @C_CALECOMP_NRSEQLOTEDIA   VARCHAR(3);
   DECLARE @C_CALECOMP_DTENTPRODPROG DATETIME;

   DECLARE @C_ITEMPEDIDO_NRPEDIDO     VARCHAR(10);
   DECLARE @C_ITEMPEDIDO_NRITEMPED    VARCHAR(10);
   DECLARE @C_ITEMPEDIDO_DTEVENTO     DATETIME;

   DECLARE @C_MPRIMAMRP_CDPRODPREVMP  VARCHAR(10);
   DECLARE @C_MPRIMAMRP_DTUTILPROD    DATETIME;
   DECLARE @C_MPRIMAMRP_QTPREVMATPRI  DOUBLE PRECISION;
   DECLARE @V_IDGERAOPCONF            VARCHAR(1);
   DECLARE @V_CDPRODFINAL             VARCHAR(10);
   DECLARE @V_IDENTRSEQ               VARCHAR(1);
   DECLARE @V_IDENTRSEQLOTE           VARCHAR(1);
   DECLARE @V_IDUTEQUIPLAPROD         VARCHAR(1);

   DECLARE @C_EQUIP_CDFILIAL         VARCHAR(4);
   DECLARE @C_EQUIP_CDEQUIPPRO       VARCHAR(10);
   DECLARE @C_EQUIP_DTHRINIUTEQUIP   DATETIME;
   DECLARE @C_EQUIP_DTHRFINUTEQUIP   DATETIME;
   DECLARE @C_EQUIP_DTPROGUTEQUIP    DATETIME;
   DECLARE @C_EQUIP_CDPRODUTO        VARCHAR(10);
   DECLARE @C_EQUIP_QTPRODPROCEQUIP  DOUBLE PRECISION;
   DECLARE @C_EQUIP_CDGRUPOEQUIPA    VARCHAR(10);
   DECLARE @C_EQUIP_CDETAPAPROD VARCHAR(10);
   DECLARE @C_EQUIP_CDINSPECAO VARCHAR(10);
   DECLARE @C_EQUIP_NRINSPETAPAPROD VARCHAR(03);
   DECLARE @V_IDMRPPEDPREV VARCHAR(1);

   DECLARE @C_SOLICITA_CDFILSOLI VARCHAR(4);
   DECLARE @C_SOLICITA_CDFILLAN VARCHAR(4);
   DECLARE @C_SOLICITA_NRSOLICMP VARCHAR(10);
   DECLARE @C_SOLICITA_DTPROGENTR DATETIME;


BEGIN
   SET @V_DSNUMELOTEPR = NULL;
   SET @V_DSSEQULOTEPR = NULL;
   SET @V_EXISPREVI    = NULL;
   SET @V_CDSETORPROD  = NULL;
   SET @V_NRSEQPREVI   = NULL;

   /* Verifica parmetros do manufatura */
   SELECT
      @V_DSNUMELOTEPR   = MAX(DSNUMELOTEPR),
      @V_DSSEQULOTEPR   = MAX(DSSEQULOTEPR),
      @V_IDSUBOPSEMIACA = ISNULL(MAX(IDSUBOPSEMIACA),'N'),
      @V_IDENTRSEQLOTE  = MAX(ISNULL(IDENTRSEQLOTE,'N')),
      @V_IDUTEQUIPLAPROD = MAX(ISNULL(IDUTEQUIPLAPROD,'N'))
   FROM
      PARAMAN M, PARAMFILIAL F
   WHERE
      M.CDFILIAL = @P_CDFILIAL    AND
      M.CDFILIAL = F.CDFILIAL;

   SET @V_NRORDENAOP  = 'X';
   SET @V_CDPRODFINAL = 'X';
   SET @V_NRSUBLOTE   = ' ';

   IF (NOT @V_DSNUMELOTEPR IS NULL) AND
      (NOT @V_DSSEQULOTEPR IS NULL) BEGIN
      /* Verifica produtos MRP para gerao de OP */
      DECLARE C_CALECOMP CURSOR FOR
         SELECT
            P.CDPRODUTO,
            PF.CDPROCFABRIC,
            TEKNISA.VALIDADE_PRODUTO(P.CDPRODUTO, P.DTCONCPROMRP) AS DTVALIDADE,
            P.DTCONCPROMRP,
            P.QTAFABRICMRP,
            P.NRORDENAOP,
            P.NRORDENASUBOP,
            P.CDPRODFINAL, NRSEQLOTEDIA, DTENTPRODPROG
          FROM
             PROCFABRICA PF,
             PRODUTO PROD,
             CALEPRODMRP P
          WHERE
             (P.CDFILIAL      = @P_CDFILIAL)     AND
             (CONVERT(VARCHAR,P.DTPROGPRODCP,103) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),103)) AND
             (CONVERT(VARCHAR,P.DTPROGPRODCP,108) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),108)) AND
             (P.QTAFABRICMRP  > 0)               AND
             (P.CDPRODUTO     = PROD.CDPRODUTO)  AND
             (PF.CDFILIAL     = P.CDFILIAL)      AND
             (PF.CDPRODUTO    = P.CDPRODUTO)     AND
             (PF.IDPROFABPADR = 'S')
          ORDER BY
             P.NRORDENAOP DESC,
             P.NRORDENASUBOP DESC,
             P.DTCONCPROMRP,
             P.CDPRODUTO;

      OPEN C_CALECOMP;
      FETCH NEXT FROM C_CALECOMP INTO @C_CALECOMP_CDPRODUTO, @C_CALECOMP_CDPROCFABRIC,
                                      @C_CALECOMP_DTVALIDADE, @C_CALECOMP_DTCONCPROMRP,
                                      @C_CALECOMP_QTAFABRICMRP, @C_CALECOMP_NRORDENAOP,
                                      @C_CALECOMP_NRORDENASUBOP, @C_CALECOMP_CDPRODFINAL,
                                      @C_CALECOMP_NRSEQLOTEDIA, @C_CALECOMP_DTENTPRODPROG;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         /* Gera o nmero do Lote de Produo */
         IF (@V_NRORDENAOP <> @C_CALECOMP_NRORDENAOP) OR (@V_IDSUBOPSEMIACA = 'N') BEGIN
            EXEC PRXLOTEPROD @P_CDFILIAL, @C_CALECOMP_DTCONCPROMRP, @C_CALECOMP_CDPRODUTO, @P_RESULT = @V_NRLOTEESTQ OUTPUT;

            /* Gera o nmero da OP/SubOP */
            SET @V_NOVOCODOP = 'NRORDPROD' + @P_CDFILIAL;
            EXEC NOVO_CODIGO_SC @V_NOVOCODOP, @V_SEQNRORDPROD OUTPUT, 1;
            SET @V_NRORDPROD = SUBSTRING(@V_SEQNRORDPROD, 11, 10);
            SET @V_NRORDENASUBOP = '0';

            SET @V_NRORDENAOP = @C_CALECOMP_NRORDENAOP;
         END;

         IF @V_CDPRODFINAL <> @C_CALECOMP_CDPRODFINAL BEGIN
            SET @V_DTVALILOTE  = @C_CALECOMP_DTVALIDADE;
            SET @V_CDPRODFINAL = @C_CALECOMP_CDPRODFINAL;
         END;

         SELECT
            @V_CTLOTE = COUNT(NRLOTEESTQ)
         FROM
            LOTE
         WHERE
            CDFILIAL     = @P_CDFILIAL    AND
            CDPRODUTO    = @C_CALECOMP_CDPRODUTO AND
            NRLOTEESTQ   = @V_NRLOTEESTQ;

         SELECT
            @V_IDGERAOPCONF = ISNULL(IDGERAOPCONF,'N'),
            @V_QTHRSEGPROD  = ISNULL(QTHRSEGPROD, 0)
         FROM PARAMPRODMRP
         WHERE
            CDFILIAL = @P_CDFILIAL AND
            CDPRODUTO = @C_CALECOMP_CDPRODUTO

         IF @V_CTLOTE = 0 BEGIN
            INSERT INTO LOTE
               (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE,
               DTENTRLOTE, DTVALILOTE, IDSTPRODLOTE, CDPLANPRODLT)
            VALUES
               (@P_CDFILIAL, @V_NRLOTEESTQ, @V_NRSUBLOTE, @C_CALECOMP_CDPRODUTO, 'I',
                @C_CALECOMP_DTCONCPROMRP, @C_CALECOMP_DTVALIDADE, '1', @P_NRPLANOPROD);
         END;

         INSERT INTO ORDPRODUCAO
            (CDFILIAL, NRORDPROD, NRSUBORDPROD, CDPRODUTO,
             CDPROCFABRIC, IDSITORDPROD, IDTIPORDPROD, DTGERORDPROD, QTAPRODPREOP,
             DTHRINIPREOP, NRLOTEESTQ, NRSUBLOTE, DSORDPROD, CDPLANPRODOP, IDCONFIRMAOP)
         VALUES
            (@P_CDFILIAL, @V_NRORDPROD, @V_NRORDENASUBOP, @C_CALECOMP_CDPRODUTO,
            @C_CALECOMP_CDPROCFABRIC, '1', '3', @C_CALECOMP_DTCONCPROMRP, @C_CALECOMP_QTAFABRICMRP,
            @C_CALECOMP_DTCONCPROMRP, @V_NRLOTEESTQ, @V_NRSUBLOTE, @P_DSORDPROD, @P_NRPLANOPROD, @V_IDGERAOPCONF);


         IF @V_IDUTEQUIPLAPROD = 'S' BEGIN
            DECLARE C_EQUIP CURSOR FOR
                            SELECT CDFILIAL, CDEQUIPPRO, DTHRINIUTEQUIP, DTHRFINUTEQUIP,
                                   DTPROGUTEQUIP, CDPRODUTO, QTPRODPROCEQUIP, CDGRUPOEQUIPA,
                                   CDETAPAPROD, CDINSPECAO, NRINSPETAPAPROD
                              FROM CALENDEQUIPAPRO
                             WHERE
                                CDFILIAL = @P_CDFILIAL AND
                                DTPROGUTEQUIP = @P_DTMRP AND
                                CDPRODUTO = @C_CALECOMP_CDPRODUTO AND
                                NRSEQLOTEDIAPRO = @C_CALECOMP_NRSEQLOTEDIA AND
                                DTCONCPRODEQUIP = @C_CALECOMP_DTCONCPROMRP;

            FETCH NEXT FROM C_EQUIP INTO @C_EQUIP_CDFILIAL, @C_EQUIP_CDEQUIPPRO, @C_EQUIP_DTHRINIUTEQUIP, @C_EQUIP_DTHRFINUTEQUIP,
                                         @C_EQUIP_DTPROGUTEQUIP, @C_EQUIP_CDPRODUTO, @C_EQUIP_QTPRODPROCEQUIP, @C_EQUIP_CDGRUPOEQUIPA,
                                         @C_EQUIP_CDETAPAPROD, @C_EQUIP_CDINSPECAO, @C_EQUIP_NRINSPETAPAPROD;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               INSERT INTO RESERVEQUIPAPRO( CDFILIAL, NRORDPROD, NRSUBORDPROD,
                                        CDEQUIPPRO, DTHRINIPROD, DTHRFINPROD,
                                        DTMRPRESEQUIP, CDPRODUTO, QTPRODRESPROC,
                                        CDGRUPOEQUIPA, CDETAPAPROD, CDINSPECAO, NRINSPETAPARES)

                                 VALUES( @P_CDFILIAL, @V_NRORDPROD, @V_NRORDENASUBOP,
                                         @C_EQUIP_CDEQUIPPRO, @C_EQUIP_DTHRINIUTEQUIP, @C_EQUIP_DTHRFINUTEQUIP,
                                         @P_DTMRP, @C_EQUIP_CDPRODUTO,  @C_EQUIP_QTPRODPROCEQUIP,
                                         @C_EQUIP_CDGRUPOEQUIPA, @C_EQUIP_CDETAPAPROD, @C_EQUIP_CDINSPECAO, @C_EQUIP_NRINSPETAPAPROD);




               FETCH NEXT FROM C_EQUIP INTO @C_EQUIP_CDFILIAL, @C_EQUIP_CDEQUIPPRO, @C_EQUIP_DTHRINIUTEQUIP, @C_EQUIP_DTHRFINUTEQUIP,
                                            @C_EQUIP_DTPROGUTEQUIP, @C_EQUIP_CDPRODUTO, @C_EQUIP_QTPRODPROCEQUIP, @C_EQUIP_CDGRUPOEQUIPA,
                                            @C_EQUIP_CDETAPAPROD, @C_EQUIP_CDINSPECAO, @C_EQUIP_NRINSPETAPAPROD;
            END;

            CLOSE C_EQUIP;
            DEALLOCATE C_EQUIP;
         END;


         SELECT @V_IDMRPPEDPREV = MAX(IDMRPPEDPREV)
         FROM PROGPRODU
         WHERE
            CDFILIAL = @P_CDFILIAL AND
            DTPROGPRODU = @P_DTMRP;



         IF ((CHARINDEX( 'P', @V_IDMRPPEDPREV) > 0)OR ( CHARINDEX('O', @V_IDMRPPEDPREV) > 0) ) BEGIN

            DECLARE C_ITEMPEDIDO CURSOR FOR
                            SELECT P.NRPEDIDO,  P.NRITEMPED
                              FROM PEDIDOMRP P, ITEMPEDIDO I
                             WHERE
                                  P.CDFILIAL =  @P_CDFILIAL AND
                                  P.DTHRPEDIDOMRP = @P_DTMRP AND
                                  P.CDFILIAL = I.CDFILIAL AND
                                  P.NRPEDIDO = I.NRPEDIDO AND
                                  P.NRITEMPED = I.NRITEMPED AND
                                  I.CDPRODUTO = @C_CALECOMP_CDPRODUTO AND
                                  (NOT EXISTS( SELECT CDFILIAL
                                                  FROM PEDIDOP
                                                 WHERE
                                                    (CDFILIAL  = I.CDFILIAL)AND
                                                    (NRPEDIDO  = I.NRPEDIDO)AND
                                                    (NRITEMPED = I.NRITEMPED)AND
                                                    (NRORDPROD = @V_NRORDPROD)AND
                                                    (NRSUBORDPROD = @V_NRORDENASUBOP)));


            OPEN C_ITEMPEDIDO;
            FETCH NEXT FROM C_ITEMPEDIDO INTO @C_ITEMPEDIDO_NRPEDIDO, @C_ITEMPEDIDO_NRITEMPED;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               INSERT INTO PEDIDOP
                  (CDFILIAL, NRORDPROD, NRSUBORDPROD, NRPEDIDO, NRITEMPED)
                  VALUES
                  (@P_CDFILIAL, @V_NRORDPROD, @V_NRORDENASUBOP, @C_ITEMPEDIDO_NRPEDIDO, @C_ITEMPEDIDO_NRITEMPED);
               FETCH NEXT FROM C_ITEMPEDIDO INTO @C_ITEMPEDIDO_NRPEDIDO, @C_ITEMPEDIDO_NRITEMPED;
            END;
            CLOSE C_ITEMPEDIDO;
            DEALLOCATE C_ITEMPEDIDO;


            DECLARE C_ITEMPEDIDO CURSOR FOR
                  SELECT DISTINCT
                     IT.NRPEDIDO,
                     IT.NRITEMPED,
                     IT.DTENTITPED
                  FROM INSUMETAPA I, ITEMPEDIDO IT, PEDIDOMRP P
                  WHERE
                        (P.CDFILIAL      = @P_CDFILIAL)
                    AND (P.DTHRPEDIDOMRP = @P_DTMRP)
                    AND (IT.CDFILIAL     = P.CDFILIAL)
                    AND (IT.NRPEDIDO     = P.NRPEDIDO)
                    AND (IT.CDPRODUTO    = I.CDPRODUTO)
                    AND (I.CDFILIAL     = @P_CDFILIAL)
                    AND (I.CDPROCFABRIC = @C_CALECOMP_CDPROCFABRIC)
                    AND (I.CDPRODINSUMO = @C_CALECOMP_CDPRODUTO)
                    AND (I.IDSEMIACETAP = 'S');


            OPEN C_ITEMPEDIDO;
            FETCH NEXT FROM C_ITEMPEDIDO INTO @C_ITEMPEDIDO_NRPEDIDO, @C_ITEMPEDIDO_NRITEMPED, @C_ITEMPEDIDO_DTEVENTO;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               INSERT INTO INSUPEDIDOP
               (CDFILIAL, NRORDPROD, NRSUBORDPROD, NRPEDIDO, NRITEMPED, CDPRODINSUMO)
               VALUES
               (@P_CDFILIAL, @V_NRORDPROD, @V_NRORDENASUBOP, @C_ITEMPEDIDO_NRPEDIDO, @C_ITEMPEDIDO_NRITEMPED, @C_CALECOMP_CDPRODUTO);

               UPDATE ORDPRODUCAO
               SET DTHRFIMPLAOP = DATEADD(HOUR, (@V_QTHRSEGPROD * -1), @C_ITEMPEDIDO_DTEVENTO)
               WHERE CDFILIAL  = @P_CDFILIAL
                 AND NRORDPROD = @V_NRORDPROD
                 AND NRSUBORDPROD = @V_NRORDENASUBOP;

               FETCH NEXT FROM C_ITEMPEDIDO INTO @C_ITEMPEDIDO_NRPEDIDO, @C_ITEMPEDIDO_NRITEMPED, @C_ITEMPEDIDO_DTEVENTO;
            END;
            CLOSE C_ITEMPEDIDO;
            DEALLOCATE C_ITEMPEDIDO;
         END
         ELSE BEGIN

            IF (CHARINDEX('S', @V_IDMRPPEDPREV) > 0)BEGIN
               DECLARE C_SOLICITA CURSOR FOR
                                  SELECT S.CDFILSOLI, S.CDFILLAN, S.NRSOLICMP, S.DTPROGENTR
                                    FROM SOLICITAMRP S
                                   WHERE
                                      S.CDFILIAL = @P_CDFILIAL AND
                                      S.DTHRSOLICITAMRP = @P_DTMRP AND
                                      S.CDPRODUTO = @C_CALECOMP_CDPRODUTO AND
                                      ( NOT EXISTS ( SELECT  CDFILIAL
                                                       FROM SOLICITAOP
                                                      WHERE
                                                         CDFILIAL = S.CDFILIAL AND
                                                         NRORDPROD = @V_NRORDPROD AND
                                                         NRSUBORDPROD = @V_NRORDENASUBOP AND
                                                         CDFILSOLI = S.CDFILSOLI AND
                                                         CDFILLAN  = S.CDFILLAN AND
                                                         NRSOLICMP = S.NRSOLICMP AND
                                                         CDPRODUTO = S.CDPRODUTO AND
                                                         DTPROGENTR = S.DTPROGENTR));
               OPEN C_SOLICITA;
               FETCH NEXT FROM C_SOLICITA INTO @C_SOLICITA_CDFILSOLI, @C_SOLICITA_CDFILLAN, @C_SOLICITA_NRSOLICMP, @C_SOLICITA_DTPROGENTR;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                     INSERT INTO SOLICITAOP( CDFILIAL, NRORDPROD, NRSUBORDPROD, CDFILSOLI, CDFILLAN, NRSOLICMP, CDPRODUTO, DTPROGENTR)
                                     VALUES( @P_CDFILIAL, @V_NRORDPROD, @V_NRORDENASUBOP, @C_SOLICITA_CDFILSOLI, @C_SOLICITA_CDFILLAN, @C_SOLICITA_NRSOLICMP, @C_CALECOMP_CDPRODUTO, @C_SOLICITA_DTPROGENTR);
                  FETCH NEXT FROM C_SOLICITA INTO @C_SOLICITA_CDFILSOLI, @C_SOLICITA_CDFILLAN, @C_SOLICITA_NRSOLICMP, @C_SOLICITA_DTPROGENTR;

               END;
               CLOSE C_SOLICITA;
               DEALLOCATE C_SOLICITA;
            END;
         END;

         UPDATE CALEPRODMRP
         SET IDGERAOPPREV = 'S'
         WHERE
            (CDFILIAL     = @P_CDFILIAL)               AND
             (CONVERT(VARCHAR,DTPROGPRODCP,103) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),103)) AND
             (CONVERT(VARCHAR,DTPROGPRODCP,108) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),108)) AND
            (CDPRODUTO    = @C_CALECOMP_CDPRODUTO)     AND
            (DTCONCPROMRP = @C_CALECOMP_DTCONCPROMRP);

         SET @V_NRORDENASUBOP = CONVERT(VARCHAR, (CONVERT(NUMERIC, @V_NRORDENASUBOP) + 1));

         FETCH NEXT FROM C_CALECOMP INTO @C_CALECOMP_CDPRODUTO, @C_CALECOMP_CDPROCFABRIC,
                                         @C_CALECOMP_DTVALIDADE, @C_CALECOMP_DTCONCPROMRP,
                                         @C_CALECOMP_QTAFABRICMRP, @C_CALECOMP_NRORDENAOP,
                                         @C_CALECOMP_NRORDENASUBOP, @C_CALECOMP_CDPRODFINAL, @C_CALECOMP_NRSEQLOTEDIA, @C_CALECOMP_DTENTPRODPROG;
      END;
      CLOSE C_CALECOMP;
      DEALLOCATE C_CALECOMP;

      /*Gera previso de compras das matrias primas do MRP*/
      SELECT
         @V_EXISPREVI = MAX(CDPRODPREVMP)
      FROM
         PREMATPPROGP
      WHERE
         CDFILIAL     = @P_CDFILIAL  AND
         (CONVERT(VARCHAR,DTPROGPRODMP,103) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),103)) AND
         (CONVERT(VARCHAR,DTPROGPRODMP,108) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),108)) AND
         QTPREVMATPRI > 0;

      IF NOT @V_EXISPREVI IS NULL BEGIN
         SELECT
            @V_CDSETORPROD = MAX(CDSETORPROD)
         FROM
            PARAMAN
         WHERE
            (CDFILIAL  = @P_CDFILIAL) AND
            (CDPARAMAN = '1');

         INSERT INTO PREVCOMP
            (CDFILIAL, NRPREVCOMP, CDSETOR, CDOPGERPRCOM, DTHRPREVCOMP, IDSTPREVCOMP)
         VALUES
            (@P_CDFILIAL, @P_NRPREVCOMP, @V_CDSETORPROD, @P_CDOPERADOR, GETDATE(), 'P');

         DECLARE C_MPRIMAMRP CURSOR FOR
            SELECT
               CDPRODPREVMP,
               DTUTILPROD,
               QTPREVMATPRI
            FROM
               PREMATPPROGP
            WHERE
               CDFILIAL     = @P_CDFILIAL  AND
               (CONVERT(VARCHAR,DTPROGPRODMP,103) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),103)) AND
               (CONVERT(VARCHAR,DTPROGPRODMP,108) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),108)) AND
               QTPREVMATPRI > 0
            ORDER BY
               CDPRODPREVMP,
               DTUTILPROD;

         OPEN C_MPRIMAMRP;
         FETCH NEXT FROM C_MPRIMAMRP INTO @C_MPRIMAMRP_CDPRODPREVMP, @C_MPRIMAMRP_DTUTILPROD,
                                          @C_MPRIMAMRP_QTPREVMATPRI;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SELECT
               @V_NRSEQPREVI = ISNULL(MAX(NRITPREVCOMP), 0) + 1
            FROM
               ITPREVCOMP
            WHERE
               CDFILIAL   = @P_CDFILIAL    AND
               NRPREVCOMP = @P_NRPREVCOMP;

            INSERT INTO ITPREVCOMP
               (CDFILIAL, NRPREVCOMP, NRITPREVCOMP, CDPRODUTO,
                DTENTPRECOMP, QTPREVCOMP)
            VALUES
               (@P_CDFILIAL, @P_NRPREVCOMP, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQPREVI), 4),
                @C_MPRIMAMRP_CDPRODPREVMP, @C_MPRIMAMRP_DTUTILPROD, @C_MPRIMAMRP_QTPREVMATPRI);

               FETCH NEXT FROM C_MPRIMAMRP INTO @C_MPRIMAMRP_CDPRODPREVMP, @C_MPRIMAMRP_DTUTILPROD,
                                                @C_MPRIMAMRP_QTPREVMATPRI;
         END;
         CLOSE C_MPRIMAMRP;
         DEALLOCATE C_MPRIMAMRP;
      END;
   END;
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_OP_PREVCOMP','5.05.016';
GO

