<?php
namespace Teknisa\Model\Avaliacao\Repositories;


class Assunto extends \Doctrine\ORM\EntityRepository {

    public function findProductCallClassificationFromRichClient($filterString = '') {
        $query = <<<SQL
        	SELECT *
        	  FROM (SELECT CDASSUNTO AS ID, NMASSUNTO AS LABEL, IDORIGOBRSOL
              		  FROM ASSUNTO
             		 WHERE NOT (INSTR(NMASSUNTO, 'INATIVO') > 0)
               		   AND CDASSUNTO IN(00010,00011,00012,00013,00021,01800))
        	 WHERE 1 = 1
            $filterString
SQL;

        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }

    public function getClassificationGep($conditions, $limit, $offset) {
        $query = <<<SQL
        	SELECT CDASSUNTO, NMASSUNTO
        	  FROM (SELECT CDASSUNTO , NMASSUNTO
              		  FROM ASSUNTO
             		 WHERE NOT (INSTR(NMASSUNTO, 'INATIVO') > 0)
               		   AND CDASSUNTO IN(00010,00011,00012,00013,00021,01800))
        	 WHERE 1 = 1
            $conditions
            ORDER BY NMASSUNTO
SQL;

        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }

    public function getClassificationPM($conditions, $limit, $offset) {
        $query = <<<SQL
        	SELECT CLASSIFICATION_ID, CLASSIFICATION_NAME
        	  FROM (SELECT ID AS CLASSIFICATION_ID, LABEL AS CLASSIFICATION_NAME
              		  FROM CLASSIFICATION
             		 WHERE IS_TASK = 'Y' AND CONTROL IS NULL)
        	 WHERE 1 = 1
            $conditions
            ORDER BY CLASSIFICATION_NAME
SQL;
        $query  = \OrganizationsManagement\Util\Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }


}